<?php

namespace App\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Notifications\Notification;
use Kutia\Larafirebase\Facades\Larafirebase;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Foundation\Bus\Dispatchable;


class AttendeesNotification extends Notification implements ShouldQueue
{
    use  Queueable;

    public $title;
    /**
     * Create a new notification instance.
     *
     * @return void
     */
    public function __construct($title)
    {   
        $this->title = $title;
    }

    /**
     * Get the notification's delivery channels.
     *
     * @param  mixed  $notifiable
     * @return array
     */
    public function via($notifiable)
    {
        return ['firebase'];
    }

    /**
     * Get the mail representation of the notification.
     *
     * @param  mixed  $notifiable
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        return (new MailMessage)
                    ->line('The introduction to the notification.')
                    ->action('Notification Action', url('/'))
                    ->line('Thank you for using our application!');
    }

    /**
     * Get the array representation of the notification.
     *
     * @param  mixed  $notifiable
     * @return array
     */
    public function toArray($notifiable)
    {
        return [
            //
        ];
    }

    

    public function toFirebase($notifiable)
    {
        $res =  Larafirebase::fromRaw([
            'registration_ids' => [$notifiable->fmc_token],
            'data' => [
                'route' => 'external_notification',
            ],
            "notification" => [
                "title" => $this->title,
                "body"  => trans('general.new_attendees'),
                "image" => null,
                "icon"  => null,
            ],
            'priority' => 'high',
        ])->send();

        return $res;
    }

}
